"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _CProgress = _interopRequireDefault(require("../progress/CProgress"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

//component - CoreUI / CWidgetProgressIcon
var CWidgetProgressIcon = function CWidgetProgressIcon(props) {
  var children = props.children,
      className = props.className,
      header = props.header,
      text = props.text,
      value = props.value,
      color = props.color,
      inverse = props.inverse,
      progressSlot = props.progressSlot,
      attributes = _objectWithoutPropertiesLoose(props, ["children", "className", "header", "text", "value", "color", "inverse", "progressSlot"]);

  var classes = (0, _classnames["default"])('card', inverse ? [color && "bg-" + color, 'text-white'] : '', className);
  return /*#__PURE__*/_react["default"].createElement("div", _extends({
    className: classes
  }, attributes), /*#__PURE__*/_react["default"].createElement("div", {
    className: "card-body"
  }, children && /*#__PURE__*/_react["default"].createElement("div", {
    className: "h1 text-muted text-right mb-4"
  }, children), header && /*#__PURE__*/_react["default"].createElement("div", {
    className: "h4 m-0"
  }, header), text && /*#__PURE__*/_react["default"].createElement("small", {
    className: "text-muted text-uppercase font-weight-bold"
  }, text), progressSlot || /*#__PURE__*/_react["default"].createElement(_CProgress["default"], {
    color: !inverse ? color : '',
    value: value,
    className: "progress-xs my-3 mb-0 " + (inverse ? 'progress-white' : '')
  })));
};

CWidgetProgressIcon.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  //
  innerRef: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].func, _propTypes["default"].string]),
  header: _propTypes["default"].string,
  text: _propTypes["default"].string,
  color: _propTypes["default"].string,
  value: _propTypes["default"].number,
  inverse: _propTypes["default"].bool,
  progressSlot: _propTypes["default"].node
} : {};
CWidgetProgressIcon.defaultProps = {
  value: 25
};
var _default = CWidgetProgressIcon;
exports["default"] = _default;
module.exports = exports.default;